; Altirra Acid800 test suite
; Copyright (C) 2010 Avery Lee, All Rights Reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE. 

	opt	h-o+
	org	0

.macro _PADSECTOR
	:(($80-*)&$7f) dta 0
.endm

	dta	$96, $02
	dta	a([diskend - imagestart]/$10)
	dta	$80
	:11 dta 0
	
	org	$0080
imagestart:
	ins	'loader.obx'

.macro _TESTADDRHI
	.if :1<10
	dta >(test0:1/$80)
	.else
	dta >(test:1/$80)
	.endif
.endm	

.macro _TESTADDRLO
	.if :1<10
	dta <(test0:1/$80)
	.else
	dta <(test:1/$80)
	.endif
.endm	

	_PADSECTOR
imageend:
	dta	<(mod00/$80)
	dta	<(mod01/$80)
	dta	<(mod02/$80)
	:43 _TESTADDRLO #
	:(<(0-*)) dta 0

	dta	>(mod00/$80)
	dta	>(mod01/$80)
	dta	>(mod02/$80)
	:43 _TESTADDRHI #
	:(<(0-*)) dta 0
	
.macro _TEST
	ins	:1
	_PADSECTOR
.endm

mod00	_TEST 'mod_options.obx'
mod01	_TEST 'mod_disp80.obx'
mod02	_TEST 'mod_vbxe80.obx'
test00	_TEST 'cpu_insn.obx'
test01	_TEST 'cpu_flags.obx'
test02	_TEST 'cpu_decimal.obx'
test03	_TEST 'cpu_timing.obx'
test04	_TEST 'cpu_bugs.obx'
test05	_TEST 'cpu_clisei.obx'
test06	_TEST 'cpu_illegal.obx'
test07	_TEST 'antic_default.obx'
test08	_TEST 'antic_nmist.obx'
test09	_TEST 'antic_hiresbug.obx'
test10	_TEST 'antic_vcount.obx'
test11	_TEST 'antic_wsync.obx'
test12	_TEST 'antic_addresswrap.obx'
test13	_TEST 'antic_dlistwrap.obx'
test14	_TEST 'antic_dlitiming.obx'
test15	_TEST 'antic_addrmirror.obx'
test16	_TEST 'antic_pmdma.obx'
test17	_TEST 'antic_charcontrol.obx'
test18	_TEST 'antic_dmapattern.obx'
test19	_TEST 'antic_blockednmi.obx'
test20	_TEST 'pokey_default.obx'
test21	_TEST 'pokey_noise.obx'
test22	_TEST 'pokey_irqtiming.obx'
test23	_TEST 'pokey_timergranularity.obx'
test24	_TEST 'pokey_twotone.obx'
test25	_TEST 'pokey_seroc.obx'
test26	_TEST 'pokey_timerirq.obx'
test27	_TEST 'pokey_asyncrecv.obx'
test28	_TEST 'pokey_addrmirror.obx'
test29	_TEST 'pokey_inittiming.obx'
test30	_TEST 'pia_basic.obx'
test31	_TEST 'pia_irq.obx'
test32	_TEST 'gtia_default.obx'
test33	_TEST 'gtia_phantomdma.obx'
test34	_TEST 'gtia_consol.obx'
test35	_TEST 'gtia_collision.obx'
test36	_TEST 'gtia_collision2.obx'
test37	_TEST 'gtia_pmretrigger.obx'
test38	_TEST 'gtia_pmresize.obx'
test39	_TEST 'gtia_psuedomodee.obx'
test40	_TEST 'gtia_addrmirror.obx'
test41	_TEST 'mmu_xlbanking.obx'
test42
	_PADSECTOR
diskend
